import { expect } from 'chai';
import AutoSaveManager from '../../auto-save';

describe('AutoSaveManager', () => {
  it('executes an immediate action', async () => {
    const element = {
        published: true,
        title: 'Some title',
        description: 'A really awesome description',
        id: 'someId',
    };
    await AutoSaveManager.saveNow(element.id, element, (key: string, el: object): Promise<any> => {
  
        return new Promise((resolve, reject) => {
            element.title = 'updated title';
            resolve(element)
        });
    });
    expect(element.title).to.be.equals('updated title');
  });

  it('executes a timed, queuable action', async () => {
    const element = {
        published: true,
        title: 'Some title',
        description: 'A really awesome description',
        id: 'someId',
    };
    const updatedElement = await AutoSaveManager.save(element.id, element, (key: string, el: object): Promise<any> => {

        return new Promise((resolve, reject) => {
            element.title = 'updated title';
            resolve(element);
        });
    }, 1000);
    expect(updatedElement.title).to.be.equals('updated title');
  });

  it('executes a timed, queuable action', async () => {
    const element = {
        published: true,
        title: 'Some title',
        description: 'A really awesome description',
        id: 'someId',
    };
    AutoSaveManager.save(element.id, element, (key: string, el: object): Promise<any> => {
  
        return new Promise((resolve, reject) => {
            element.title = 'updated title';
            resolve(element);
        });
    }, 1000);
    const updatedElement = await AutoSaveManager.save(element.id, element, (key: string, el: object): Promise<any> => {

      return new Promise((resolve, reject) => {
          element.title = 'second update';
          resolve(element);
      });
    }, 1000);
    expect(updatedElement.title).to.be.equals('updated title');
  });

});
